#pragma once

#include <filesystem>

#include "../base/MemoryBase.h"

#include "CoreSegment.h"

#include "../workingmemory/Memory.h"

namespace armarx::armem::d_ltm
{

    /**
     * @brief Data of a memory consisting of multiple core segments.
     */
    class Memory :
        virtual public base::MemoryBase<CoreSegment, Memory>
    {
        using Base = base::MemoryBase<CoreSegment, Memory>;

    public:
        Memory();
        Memory(const std::string& name);
        Memory(const MemoryID& id);

        Memory(const Memory& other);
        Memory& operator=(const Memory& other);

        // Conversion
        wm::Memory convert() const;

        // Filesystem connection
        void reload(const std::filesystem::path&);
        void append(const wm::Memory&);

    private:
        std::filesystem::path _fullPath() const;
        std::filesystem::path _fullPath(const std::filesystem::path&) const;

    public:
        std::shared_ptr<std::filesystem::path> path;
    };
}
