#pragma once

#include "../base/CoreSegmentBase.h"

#include "ProviderSegment.h"

#include "../workingmemory/CoreSegment.h"


namespace armarx::armem::ltm
{

    /**
     * @brief Data of a core segment containing multiple provider segments.
     */
    class CoreSegment :
        virtual public base::CoreSegmentBase<ProviderSegment, CoreSegment>
    {
        using Base = base::CoreSegmentBase<ProviderSegment, CoreSegment>;

    public:
        CoreSegment();
        CoreSegment(const std::string& name, aron::typenavigator::ObjectNavigatorPtr aronType = nullptr);
        CoreSegment(const std::string& name, const MemoryID& parentID, aron::typenavigator::ObjectNavigatorPtr aronType = nullptr);
        CoreSegment(const MemoryID& id, aron::typenavigator::ObjectNavigatorPtr aronType = nullptr);

        CoreSegment(const CoreSegment& other);
        CoreSegment& operator=(const CoreSegment& other);

        // Conversion
        wm::CoreSegment convert() const;

        // MongoDB connection
        void append(const wm::CoreSegment&);
    };

}
