#include "Entity.h"

namespace armarx::armem::ltm
{

    Entity::Entity()
    {
    }

    Entity::Entity(const std::string& name, const MemoryID& parentID) :
        base::detail::MemoryItem(parentID.withEntityName(name))
    {
    }

    Entity::Entity(const MemoryID& id) :
        base::detail::MemoryItem(id)
    {
    }

    Entity::Entity(const Entity& other) :
        base::detail::MemoryItem(other),
        base::detail::MemoryContainerBase<std::map<Time, EntitySnapshot>, Entity>(other)
    {
    }

    Entity& Entity::operator=(const Entity& other)
    {
        other._copySelf(*this);
        return *this;
    }

    wm::Entity Entity::convert() const
    {
        wm::Entity m;
        for (const auto& [_, s] : _container)
        {
            m.addSnapshot(s.convert());
        }
        return m;
    }

    void Entity::append(const wm::Entity& m)
    {
        for (const auto& [k, s] : m.container())
        {
            if (const auto& it = _container.find(k); it != _container.end())
            {
                it->second.setTo(s);
            }
            else
            {
                auto wms = _container.emplace(std::make_pair(k, id().withTimestamp(k)));
                wms.first->second.setTo(s);
            }
        }
    }
}
