#include "EntitySnapshot.h"

#include <ArmarXCore/core/exceptions/local/ExpressionException.h>

#include "error.h"


namespace armarx::armem::ltm
{


    EntitySnapshot::EntitySnapshot()
    {
    }

    EntitySnapshot::EntitySnapshot(Time time, const MemoryID& parentID) :
        EntitySnapshot(parentID.withTimestamp(time))
    {
    }

    EntitySnapshot::EntitySnapshot(const MemoryID& id) :
        MemoryItem(id)
    {
    }

    EntitySnapshot::EntitySnapshot(const EntitySnapshot& other) :
        base::detail::MemoryItem(other),
        base::detail::MemoryContainerBase<std::vector<EntityInstance>, EntitySnapshot>(other)
    {
    }

    EntitySnapshot& EntitySnapshot::operator=(const EntitySnapshot& other)
    {
        other._copySelf(*this);
        return *this;
    }

    wm::EntitySnapshot EntitySnapshot::convert() const
    {
        wm::EntitySnapshot m;
        for (const auto& s : _container)
        {
            m.addInstance(s.convert());
        }
        return m;
    }

    void EntitySnapshot::setTo(const wm::EntitySnapshot& m)
    {
        // We remove the contente here and reset it with new values
        _container.clear();

        int i = 0;
        for (const auto& s : m.container())
        {
            auto wms = _container.emplace_back(id().withInstanceIndex(i++));
            wms.setTo(s);
        }
    }
}
