#pragma once

#include "../base/MemoryBase.h"

#include "CoreSegment.h"

#include "../workingmemory/Memory.h"
#include "mongodb/MongoDBConnectionManager.h"

namespace armarx::armem::ltm
{
    /**
     * @brief Data of a memory consisting of multiple core segments.
     */
    class Memory :
        virtual public base::MemoryBase<CoreSegment, Memory>
    {
        using Base = base::MemoryBase<CoreSegment, Memory>;

    public:
        Memory();
        Memory(const std::string& name);
        Memory(const MemoryID& id);

        Memory(const Memory& other);
        Memory& operator=(const Memory& other);


        // Conversion
        wm::Memory convert() const;

        // MongoDB connection
        void reload(const MongoDBConnectionManager::MongoDBSettings&);
        void append(const wm::Memory&);


    public:
        MongoDBConnectionManager::MongoDBSettings dbsettings;
    };
}
