#pragma once

#include "../base/ProviderSegmentBase.h"

#include "Entity.h"

#include "../workingmemory/ProviderSegment.h"


namespace armarx::armem::ltm
{

    /**
     * @brief Data of a provider segment containing multiple entities.
     */
    class ProviderSegment :
        virtual public base::ProviderSegmentBase<Entity, ProviderSegment>
    {
        using Base = base::ProviderSegmentBase<Entity, ProviderSegment>;

    public:
        ProviderSegment();
        ProviderSegment(const std::string& name, aron::typenavigator::ObjectNavigatorPtr aronType = nullptr);
        ProviderSegment(const std::string& name, const MemoryID parentID, aron::typenavigator::ObjectNavigatorPtr aronType = nullptr);
        ProviderSegment(const MemoryID id, aron::typenavigator::ObjectNavigatorPtr aronType = nullptr);

        ProviderSegment(const ProviderSegment& other);
        ProviderSegment& operator=(const ProviderSegment& other);

        // Conversion
        wm::ProviderSegment convert() const;

        // MongoDB connection
        void append(const wm::ProviderSegment&);
    };

}
