#include "CoreSegment.h"

#include <ArmarXCore/core/exceptions/local/ExpressionException.h>

#include "error.h"


namespace armarx::armem::wm
{

    CoreSegment::CoreSegment()
    {
    }

    CoreSegment::CoreSegment(const std::string& name, aron::typenavigator::ObjectNavigatorPtr aronType) :
        base::detail::MemoryItem(MemoryID().withCoreSegmentName(name)),
        base::detail::TypedEntityContainerBase<ProviderSegment, Entity, CoreSegment>(MemoryID().withCoreSegmentName(name), aronType)
    {
    }

    CoreSegment::CoreSegment(const std::string& name, const MemoryID& parentID, aron::typenavigator::ObjectNavigatorPtr aronType) :
        base::detail::MemoryItem(MemoryID().withCoreSegmentName(name)),
        base::detail::TypedEntityContainerBase<ProviderSegment, Entity, CoreSegment>(parentID.withCoreSegmentName(name), aronType)
    {
    }

    CoreSegment::CoreSegment(const MemoryID& id, aron::typenavigator::ObjectNavigatorPtr aronType) :
        base::detail::MemoryItem(id),
        base::detail::TypedEntityContainerBase<ProviderSegment, Entity, CoreSegment>(id, aronType)
    {
    }

    CoreSegment::CoreSegment(const CoreSegment& other) :
        base::detail::MemoryItem(other),
        base::detail::MemoryContainerBase<std::map<std::string, ProviderSegment>, CoreSegment>(other),
        base::detail::TypedEntityContainerBase<ProviderSegment, Entity, CoreSegment>(other)
    {
    }

    CoreSegment& CoreSegment::operator=(const CoreSegment& other)
    {
        other._copySelf(*this);
        return *this;
    }

    CoreSegment CoreSegment::copyWithoutData() const
    {
        CoreSegment m;
        _copySelfWithoutData(m);
        return m;
    }

    void CoreSegment::_copySelfWithoutData(CoreSegment& o) const
    {
        detail::TypedEntityContainer<ProviderSegment, CoreSegment>::_copySelfWithoutData(o);
        for (const auto& [k, s] : o)
        {
            o.addProviderSegment(s.copyWithoutData());
        }
    }
}
