#pragma once

#include "../base/CoreSegmentBase.h"

#include "ProviderSegment.h"
#include "detail/TypedEntityContainer.h"


namespace armarx::armem::wm
{

    /**
     * @brief Data of a core segment containing multiple provider segments.
     */
    class CoreSegment :
        virtual public base::CoreSegmentBase<ProviderSegment, CoreSegment>,
        virtual public detail::TypedEntityContainer<ProviderSegment, CoreSegment>
    {
        using Base = base::CoreSegmentBase<ProviderSegment, CoreSegment>;

    public:
        CoreSegment();
        CoreSegment(const std::string& name, aron::typenavigator::ObjectNavigatorPtr aronType = nullptr);
        CoreSegment(const std::string& name, const MemoryID& parentID, aron::typenavigator::ObjectNavigatorPtr aronType = nullptr);
        CoreSegment(const MemoryID& id, aron::typenavigator::ObjectNavigatorPtr aronType = nullptr);

        CoreSegment(const CoreSegment& other);
        CoreSegment& operator=(const CoreSegment& other);

        CoreSegment copyWithoutData() const override;

    protected:
        virtual void _copySelfWithoutData(CoreSegment& o) const override;
    };

}
