#include "Entity.h"

namespace armarx::armem::wm
{

    Entity::Entity()
    {
    }

    Entity::Entity(const std::string& name, const MemoryID& parentID) :
        base::detail::MemoryItem(parentID.withEntityName(name))
    {
    }

    Entity::Entity(const MemoryID& id) :
        base::detail::MemoryItem(id)
    {
    }

    Entity::Entity(const Entity& other) :
        base::detail::MemoryItem(other),
        base::detail::MemoryContainerBase<std::map<Time, EntitySnapshot>, Entity>(other)
    {
    }

    Entity& Entity::operator=(const Entity& other)
    {
        other._copySelf(*this);
        return *this;
    }

    Entity Entity::copyWithoutData() const
    {
        Entity m;
        _copySelfWithoutData(m);
        return m;
    }

    void Entity::_copySelfWithoutData(Entity& o) const
    {
        detail::MemoryContainer<std::map<Time, EntitySnapshot>, Entity>::_copySelfWithoutData(o);
        for (const auto& [k, s] : o)
        {
            o.addSnapshot(s.copyWithoutData());
        }
    }
}
