#include "EntitySnapshot.h"

#include <ArmarXCore/core/exceptions/local/ExpressionException.h>

#include "error.h"


namespace armarx::armem::wm
{


    EntitySnapshot::EntitySnapshot()
    {
    }

    EntitySnapshot::EntitySnapshot(Time time, const MemoryID& parentID) :
        EntitySnapshot(parentID.withTimestamp(time))
    {
    }

    EntitySnapshot::EntitySnapshot(const MemoryID& id) :
        MemoryItem(id)
    {
    }

    EntitySnapshot::~EntitySnapshot()
    {
    }

    EntitySnapshot::EntitySnapshot(const EntitySnapshot& other) :
        base::detail::MemoryItem(other),
        base::detail::MemoryContainerBase<std::vector<EntityInstance>, EntitySnapshot>(other)
    {
    }

    EntitySnapshot& EntitySnapshot::operator=(const EntitySnapshot& other)
    {
        other._copySelf(*this);
        return *this;
    }

    EntitySnapshot EntitySnapshot::copyWithoutData() const
    {
        EntitySnapshot m;
        _copySelfWithoutData(m);
        return m;
    }

    void EntitySnapshot::_copySelfWithoutData(EntitySnapshot& o) const
    {
        detail::MemoryContainer<std::vector<EntityInstance>, EntitySnapshot>::_copySelfWithoutData(o);
        for (const auto& s : o)
        {
            o.addInstance(s.copyWithoutData());
        }
    }
}
