#pragma once

#include "../base/EntitySnapshotBase.h"

#include "EntityInstance.h"
#include "detail/MemoryContainer.h"


namespace armarx::armem::wm
{

    /**
     * @brief Data of an entity at one point in time.
     */
    class EntitySnapshot :
        virtual public base::EntitySnapshotBase<EntityInstance, EntitySnapshot>,
        virtual public detail::MemoryContainer<std::vector<EntityInstance>, EntitySnapshot>
    {
        using Base = base::EntitySnapshotBase<EntityInstance, EntitySnapshot>;

    public:

        EntitySnapshot();
        EntitySnapshot(Time time, const MemoryID& parentID = {});
        EntitySnapshot(const MemoryID& id);

        virtual ~EntitySnapshot() override;


        /// Copy the instances from `other` to this.
        EntitySnapshot(const EntitySnapshot& other);

        /// Copy the instances from `other` to this.
        EntitySnapshot& operator=(const EntitySnapshot& other);

        EntitySnapshot copyWithoutData() const override;


    protected:

        virtual void _copySelfWithoutData(EntitySnapshot& o) const override;

    };
}
