#include "Memory.h"

#include <ArmarXCore/core/logging/Logging.h>
#include <ArmarXCore/core/exceptions/local/ExpressionException.h>

#include "error.h"


namespace armarx::armem::wm
{

    Memory::Memory()
    {
    }

    Memory::Memory(const std::string& name) :
        base::detail::MemoryItem(MemoryID().withMemoryName(name))
    {
    }

    Memory::Memory(const MemoryID& id) :
        MemoryItem(id)
    {
    }

    Memory::Memory(const Memory& other) :
        base::detail::MemoryItem(other),
        MemoryContainerBase<std::map<std::string, CoreSegment>, Memory>(other)
    {
        *this = other;
    }

    Memory& Memory::operator=(const Memory& other)
    {
        other._copySelf(*this);
        return *this;
    }

    Memory Memory::copyWithoutData() const
    {
        Memory m;
        _copySelfWithoutData(m);
        return m;
    }

    void Memory::_copySelfWithoutData(Memory& o) const
    {
        detail::EntityContainer<CoreSegment, Memory>::_copySelfWithoutData(o);
        for (const auto& [k, s] : o)
        {
            o.addCoreSegment(s.copyWithoutData());
        }
    }
}
