#pragma once

#include "../base/MemoryBase.h"

#include "CoreSegment.h"
#include "detail/EntityContainer.h"

namespace armarx::armem::wm
{

    /**
     * @brief Data of a memory consisting of multiple core segments.
     */
    class Memory :
        virtual public base::MemoryBase<CoreSegment, Memory>,
        virtual public detail::EntityContainer<CoreSegment, Memory>
    {
        using Base = base::MemoryBase<CoreSegment, Memory>;

    public:
        Memory();
        Memory(const std::string& name);
        Memory(const MemoryID& id);

        Memory(const Memory& other);
        Memory& operator=(const Memory& other);

        Memory copyWithoutData() const override;

    protected:
        virtual void _copySelfWithoutData(Memory& o) const override;
    };
}
