#include "ProviderSegment.h"

#include <ArmarXCore/core/exceptions/local/ExpressionException.h>

#include "error.h"


namespace armarx::armem::wm
{

    ProviderSegment::ProviderSegment()
    {
    }

    ProviderSegment::ProviderSegment(const std::string& name, aron::typenavigator::ObjectNavigatorPtr aronType) :
        base::detail::MemoryItem(MemoryID().withProviderSegmentName(name)),
        base::detail::TypedEntityContainerBase<Entity, Entity, ProviderSegment>(MemoryID().withProviderSegmentName(name), aronType)
    {
    }

    ProviderSegment::ProviderSegment(const std::string& name, const MemoryID parentID, aron::typenavigator::ObjectNavigatorPtr aronType) :
        base::detail::MemoryItem(parentID.withProviderSegmentName(name)),
        base::detail::TypedEntityContainerBase<Entity, Entity, ProviderSegment>(parentID.withProviderSegmentName(name), aronType)
    {
    }

    ProviderSegment::ProviderSegment(const MemoryID id, aron::typenavigator::ObjectNavigatorPtr aronType) :
        base::detail::MemoryItem(id),
        base::detail::TypedEntityContainerBase<Entity, Entity, ProviderSegment>(id, aronType)
    {
    }

    ProviderSegment::ProviderSegment(const ProviderSegment& other) :
        base::detail::MemoryItem(other),
        base::detail::MemoryContainerBase<std::map<std::string, Entity>, ProviderSegment>(other),
        base::detail::TypedEntityContainerBase<Entity, Entity, ProviderSegment>(other)
    {
    }

    ProviderSegment& ProviderSegment::operator=(const ProviderSegment& other)
    {
        other._copySelf(*this);
        return *this;
    }

    ProviderSegment ProviderSegment::copyWithoutData() const
    {
        ProviderSegment m;
        _copySelfWithoutData(m);
        return m;
    }

    void ProviderSegment::_copySelfWithoutData(ProviderSegment& o) const
    {
        detail::TypedEntityContainer<Entity, ProviderSegment>::_copySelfWithoutData(o);
        for (const auto& [k, s] : o)
        {
            o.addEntity(s.copyWithoutData());
        }
    }

}
