#pragma once

#include "../base/ProviderSegmentBase.h"

#include "Entity.h"
#include "detail/TypedEntityContainer.h"


namespace armarx::armem::wm
{

    /**
     * @brief Data of a provider segment containing multiple entities.
     */
    class ProviderSegment :
        virtual public base::ProviderSegmentBase<Entity, ProviderSegment>,
        virtual public detail::TypedEntityContainer<Entity, ProviderSegment>
    {
        using Base = base::ProviderSegmentBase<Entity, ProviderSegment>;

    public:
        ProviderSegment();
        ProviderSegment(const std::string& name, aron::typenavigator::ObjectNavigatorPtr aronType = nullptr);
        ProviderSegment(const std::string& name, const MemoryID parentID, aron::typenavigator::ObjectNavigatorPtr aronType = nullptr);
        ProviderSegment(const MemoryID id, aron::typenavigator::ObjectNavigatorPtr aronType = nullptr);

        ProviderSegment(const ProviderSegment& other);
        ProviderSegment& operator=(const ProviderSegment& other);

        ProviderSegment copyWithoutData() const override;

    protected:
        virtual void _copySelfWithoutData(ProviderSegment& o) const override;
    };

}
