#pragma once

#include "../../base/detail/EntityContainerBase.h"
#include "MemoryContainer.h"

#include "../Entity.h"
#include "../EntitySnapshot.h"
#include "../EntityInstance.h"


namespace armarx::armem::wm::detail
{

    /**
     * @brief A container of entities at some point in the hierarchy.
     *
     * Can be updated by multiple entity updates.
     */
    template <class _ValueT, class _Derived>
    class EntityContainer :
        virtual public base::detail::EntityContainerBase<_ValueT, Entity, _Derived>,
        virtual public MemoryContainer<std::map<std::string, _ValueT>, _Derived>
    {
    public:
        EntityContainer& operator=(const EntityContainer& other)
        {
            other._copySelf(*this);
            return *this;
        }
    };

}
