#pragma once

#include <ArmarXCore/core/exceptions/local/ExpressionException.h>

#include "../../error.h"

#include "../../base/detail/MemoryContainerBase.h"


namespace armarx::armem::wm::detail
{

    /**
     * @class Provides default implmentations of `MemoryContainer`, as well as
     * iterators (which requires a template).
     */
    template <class _ContainerT, class _Derived>
    class MemoryContainer :
        virtual public base::detail::MemoryContainerBase<_ContainerT, _Derived>
    {
        using Base = base::detail::MemoryContainerBase<_ContainerT, _Derived>;

    public:
        MemoryContainer& operator=(const MemoryContainer& other)
        {
            other._copySelf(*this);
            return *this;
        }

        // Copying
        virtual _Derived copyWithoutData() const
        {
            _Derived t;
            _copySelfWithoutData(t);
            return t;
        }

    protected:
        virtual void _copySelfWithoutData(_Derived& o) const
        {
            Base::_copySelfEmpty(o);
        }
    };
}
